SystemOrganization addCategory: #'LizViz-Traits'!

Trait named: #TZzAddFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 18:43:55.366'!
add: anItemValue
	
	^ self addFirst: anItemValue! !

!TZzAddFirstOperation methodsFor: 'as yet unclassified' stamp: 'or 6/20/2013 12:19:59.446'!
addFirst: anItemValue
	
	| newItem |
	newItem := self createItem
		nextItem: self firstItem;
		previousItem: nil;
		value: anItemValue.
	self firstItem: newItem.
	self firstItem nextItem ifNotNilDo: [:item | 
		(item respondsTo: #previousItem) ifTrue: [item previousItem: newItem]].
	^ newItem! !

Trait named: #TZzAddLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddLastOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:45:05.058'!
addLast: anItemValue
	
	| lastItem currentItem newItem |
	lastItem := self firstItem.
	lastItem ifNil: [
		newItem := self createItem
			nextItem: nil;
			previousItem: nil;
			value: anItemValue.
		self firstItem: newItem.
		^ newItem].
	
	currentItem := lastItem.
	[currentItem isNil not]
		whileTrue: [
			lastItem := currentItem.
			currentItem := currentItem nextItem].
	
	newItem := self createItem
		nextItem: nil;
		previousItem: lastItem;
		value: anItemValue.
	
	lastItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzAddOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:45:12.668'!
add: anItemValue at: anIndex
	
	| linkingItem newItem |
	self firstItem ifNil: [^ self].
	
	linkingItem := self firstItem.
	(anIndex - 1 > 0 and: [linkingItem nextItem isNil not])
		whileTrue: [linkingItem := linkingItem nextItem].
	
	(anIndex - 1 > 0) ifTrue: [self error: 'index out of bounds'].
	
	newItem := self createItem
		nextItem: linkingItem nextItem;
		previousItem: linkingItem;
		value: anItemValue.
	"newItem previousItem: linkingItem."
	linkingItem nextItem previousItem: newItem.
	"newItem nextItem: linkingItem nextItem."
	linkingItem nextItem: newItem.
	^ newItem! !

Trait named: #TZzAddSetOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzAddSetOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 14:46:00.702'!
add: aValue! !

Trait named: #TZzDequeueOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzDequeueOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 14:39:12.654'!
dequeue! !

Trait named: #TZzEnqueueOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzEnqueueOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 14:39:31.388'!
enqueue: aValue! !

Trait named: #TZzIsEmptyOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzIsEmptyOperation methodsFor: 'as yet unclassified' stamp: 'ls 5/27/2013 19:48:15.168'!
isEmpty
	
	^ self firstItem isNil! !

Trait named: #TZzPopOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPopOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 12:55:27.487'!
pop

	| item |
	item := self firstItem.
	item isNil ifTrue: [^ nil].
	self firstItem: item nextItem.
	^ item! !

Trait named: #TZzPushOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzPushOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:48:36.106'!
push: aValue

	| newItem |
	newItem := self createItem
		nextItem: self firstItem;
		value: aValue.
	self firstItem: newItem.! !

Trait named: #TZzRemoveFirstOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveFirstOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 15:52:41.374'!
removeFirst
	
	| first next |
	first := self firstItem.
	first ifNil: [^ nil].
	next := first nextItem.
	self firstItem: next.
	(next respondsTo: #previousItem) ifTrue: [ next previousItem: nil].
	^ first! !

Trait named: #TZzRemoveLastOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveLastOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 15:42:25.708'!
removeLast
	
	| previousItem item |
	previousItem := self firstItem.
	previousItem ifNil: [^ self].
	
	item := previousItem.
	[item nextItem isNil not] whileTrue: 
		[previousItem := item.
		item := item nextItem].
	previousItem nextItem: nil.! !

Trait named: #TZzRemoveValueOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzRemoveValueOperation methodsFor: 'as yet unclassified' stamp: 'or 6/25/2013 14:39:43.044'!
remove: aValue! !

Trait named: #TZzSizeOperation
	uses: {}
	category: 'LizViz-Traits'!

!TZzSizeOperation methodsFor: 'as yet unclassified' stamp: 'JR 6/11/2013 13:17:03.242'!
size
	
	| size nextItem |
	size := 0.
	nextItem := self firstItem.
	[nextItem isNil not] whileTrue: 
		[size := size + 1.
		nextItem := nextItem nextItem].
	^ size! !
